﻿/*
   Copyright 2011 Softisis

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

using System.Reflection;

namespace FOM.Utils
{
    /// <summary>
    /// Info on a digged object
    /// </summary>
    /// <remarks>Copyright Softisis 2011 (France)</remarks>
    public class DiggedObjectInfos
    {
        /// <summary>
        /// The targetted property. Will be null for root object.
        /// </summary>
        internal PropertyInfo TargetProperty { get; private set; }

        /// <summary>
        /// Object containing the TargetProperty. Null for root obejct (because no parent object)
        /// </summary>
        internal object ContainingObject { get; private set; }

        /// <summary>
        /// The value contained in the target
        /// </summary>
        internal object TargetedValue { get; private set; }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="tgtProp">The targetted property.</param>
        /// <param name="contObj">Object containing the TargetProperty</param>
        /// <param name="tgtval">he value contained in the target</param>
        internal DiggedObjectInfos(PropertyInfo tgtProp, object contObj, object tgtval)
        {
            TargetProperty = tgtProp;
            ContainingObject = contObj;
            TargetedValue = tgtval;
        }

    }
}
